<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_Default" %>

<asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>
    
<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>
    <asp:Label ID="LblErr" runat="server" Text="" CssClass="errore"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>
    <br />

    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0">
    
        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar">
                <asp:Button ID="BtnNew" runat="server" Text="Nuovo" CssClass="button" OnClick="BtnNew_Click" />&nbsp;
                <asp:Button ID="BtnApplySettings" runat="server" Text="Applica" CssClass="button" OnClick="BtnApply_Click" />
            </div>
            <br />
            <asp:GridView ID="Grid1" runat="server" AllowPaging="True" AllowSorting="false" Width="100%" AutoGenerateColumns="False"
                DataSourceID="ObjDs1" DataKeyNames="KeyName" OnRowCommand="Grid1_RowCommand" OnRowCreated="Grid1_RowCreated" OnRowDataBound="Grid1_RowDataBound">
                <Columns>
                    <asp:TemplateField ItemStyle-VerticalAlign="Top">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkSel" CommandName="Select" CommandArgument='<%#Eval("KeyName") %>' 
                        runat="server" SkinID="ImgEditFile" />                
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="KeyName" HeaderText="Nome" SortExpression="KeyName" ItemStyle-VerticalAlign="Top" />
                    <asp:BoundField DataField="KeyTitle" HeaderText="Titolo" SortExpression="KeyTitle" ItemStyle-VerticalAlign="Top" />
                    <asp:TemplateField ItemStyle-VerticalAlign="Top">
                        <ItemTemplate>
                        <asp:Label runat="server" ID="LblKeyValue"></asp:Label>
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField ItemStyle-HorizontalAlign="Right" HeaderStyle-Width="20" ItemStyle-VerticalAlign="Top">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkDel" CommandName="DeleteRow" CommandArgument='<%#Eval("KeyName") %>' runat="server" SkinID="ImgDelFile" 
                        OnClientClick="return confirm('Cancellare la riga?');"  />
                        </ItemTemplate>
                    </asp:TemplateField>
                </Columns>
            </asp:GridView>
            
            <asp:ObjectDataSource ID="ObjDs1" runat="server" SelectMethod="GetSettings" TypeName="PigeonCms.AppSettingsManager">
                <SelectParameters></SelectParameters>
                <DeleteParameters>
                    <asp:Parameter Name="KeyName" Type="String" />
                </DeleteParameters>
            </asp:ObjectDataSource>
        </asp:View>
   
        <asp:View ID="ViewInsert" runat="server">
            <div class="adminToolbar">
                <asp:Button ID="BtnSave" runat="server" Text="Salva" CssClass="button" OnClick="BtnSave_Click" />
                <asp:Button ID="BtnCancel" runat="server" Text="Annulla" CssClass="button" OnClick="BtnCancel_Click" />
            </div>
        
            <div class="col width-100">
            <fieldset class="adminForm">
                <legend></legend>
                <asp:HiddenField ID="HiddenNewRecord" runat="server" />
                <table class="adminTable">
                <tr>
                    <td class="key">Key Name</td>
                    <td style="width: 571px">
                        <asp:TextBox ID="TxtKeyName" MaxLength="50" runat="server" Enabled="false" CssClass="adminText"></asp:TextBox>
                    </td>
                </tr>          
                <tr>
                    <td class="key">Titolo</td>
                    <td>
                        <asp:TextBox ID="TxtKeyTitle" MaxLength="500" runat="server" CssClass="adminText" Height="50px" TextMode="MultiLine"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="key">Valore</td>
                    <td>
                        <asp:TextBox ID="TxtKeyValue" MaxLength="500" runat="server" CssClass="adminText"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="key">Info aggiuntive</td>
                    <td>
                        <asp:TextBox ID="TxtKeyInfo" MaxLength="500" runat="server" CssClass="adminText" Height="50px" TextMode="MultiLine"></asp:TextBox>
                    </td>
                </tr>
                </table>
            </fieldset>
            </div>
        </asp:View>
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>