<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_CommentsAdmin" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="cc1" %>
<%@ Register src="~/Controls/ItemParams.ascx" tagname="ItemParams" tagprefix="uc1" %>
<%@ Register src="~/Controls/PermissionsControl.ascx" tagname="PermissionsControl" tagprefix="uc1" %>

<script type="text/javascript">
// <!CDATA[

//use in popup version
function closePopup() { parent.$.fancybox.close(); }
// ]]>
</script>

<asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>

<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>

    <h1><%=base.GetLabel("ModuleTitle", "Comments")%></h1>
    <asp:Label ID="LblErr" runat="server" Text="" CssClass="error"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>

    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0" OnActiveViewChanged="MultiView1_ActiveViewChanged">

        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar">
            </div>
            <fieldset>
                <%=base.GetLabel("LblFilters")%>&nbsp;
                <asp:DropDownList ID="DropStatusFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropStatusFilter_SelectedIndexChanged">
                </asp:DropDownList>
                <asp:TextBox ID="TxtSearchFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" 
                    ontextchanged="TxtSearchFilter_TextChanged"></asp:TextBox>
                <cc1:TextBoxWatermarkExtender TargetControlID="TxtSearchFilter" runat="server" 
                    WatermarkText="<search>" WatermarkCssClass="adminMediumText watermark">
                </cc1:TextBoxWatermarkExtender>
            </fieldset>
            <br />
            <asp:GridView ID="Grid1" runat="server" AllowPaging="True" AllowSorting="true" Width="100%" AutoGenerateColumns="False"
                DataSourceID="ObjDs1" DataKeyNames="Id" OnRowCommand="Grid1_RowCommand" OnRowCreated="Grid1_RowCreated" OnRowDataBound="Grid1_RowDataBound">
                <Columns>
                    <asp:TemplateField ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkSel" CommandName="Select" CommandArgument='<%#Eval("Id") %>' 
                        runat="server" SkinID="ImgEditFile" />                
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="Title" HeaderText="Titolo" SortExpression="" />
                    <asp:BoundField DataField="Alias" HeaderText="Alias" SortExpression="Alias" />
                    <asp:TemplateField HeaderText="Sezione" ItemStyle-HorizontalAlign="Left" HeaderStyle-HorizontalAlign="Left">
                        <ItemTemplate>
                            <asp:Literal ID="LitSectionTitle" runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField HeaderText="Categoria" ItemStyle-HorizontalAlign="Left" HeaderStyle-HorizontalAlign="Left">
                        <ItemTemplate>
                            <asp:Literal ID="LitCategoryTitle" runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="ItemTypeName" HeaderText="Tipo" SortExpression="ItemType" />
                        
                    <asp:TemplateField HeaderText="Abilitato" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                            <asp:ImageButton runat="server" ID="ImgEnabledOk" CommandName="ImgEnabledOk" CommandArgument='<%#Eval("Id") %>' SkinID="ImgOk" Visible="false" />
                            <asp:ImageButton runat="server" ID="ImgEnabledKo" CommandName="ImgEnabledKo" CommandArgument='<%#Eval("Id") %>' SkinID="ImgUnchecked" Visible="false" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Access type" SortExpression="AccessType">
                        <ItemTemplate>
                        <asp:Literal ID="LitAccessTypeDesc" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Access Level" SortExpression="AccessCode, AccessLevel">
                        <ItemTemplate>
                        <asp:Literal ID="LitAccessLevel" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Cancella" ItemStyle-HorizontalAlign="Center" ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkDel" CommandName="DeleteRow" CommandArgument='<%#Eval("Id") %>' 
                        runat="server" SkinID="ImgDelFile" 
                        OnClientClick="return confirm('Cancellare la riga?');"  />
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:BoundField DataField="Id" HeaderText="ID" SortExpression="Id" ItemStyle-HorizontalAlign="Right" HeaderStyle-HorizontalAlign="Right" />
                </Columns>
            </asp:GridView>
            
            <asp:ObjectDataSource ID="ObjDs1" runat="server" SortParameterName="sort" SelectMethod="GetByFilter" 
                TypeName="PigeonCms.ItemsManager`2[[PigeonCms.Item],[PigeonCms.ItemsFilter]]" OnSelecting="ObjDs1_Selecting">
                <SelectParameters>
                    <asp:Parameter Name="filter" Type="Object" />
                    <asp:Parameter Name="sort" Type="String" DefaultValue="Ordering" />
                </SelectParameters>
                <DeleteParameters>
                    <asp:Parameter Name="Id" Type="Int32" />
                </DeleteParameters>
            </asp:ObjectDataSource>
        </asp:View>
   

        <asp:View ID="ViewInsert" runat="server">
        
            <div class="adminToolbar">
                <asp:Button ID="BtnSave" runat="server" Text="<%$ Resources:PublicLabels, CmdSave %>" CssClass="button" OnClientClick="MyObject.UpdateEditorFormValue();" OnClick="BtnSave_Click" />
                <asp:Button ID="BtnCancel" runat="server" Text="<%$ Resources:PublicLabels, CmdCancel %>" CssClass="button" CausesValidation="false" OnClick="BtnCancel_Click" />
            </div>
            
            <div class="col width-60">
                <fieldset class="adminForm">
                    <legend></legend>
                    <table class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblItemType", "Item type", null, true)%></td>
                        <td colspan="3">
                            <asp:Literal ID="LitItemType" runat="server"></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblCategory", "Category", DropCategories, true)%></td>
                        <td style="width: 500px">
                            <asp:DropDownList ID="DropCategories" runat="server" CssClass=""></asp:DropDownList>&nbsp;&nbsp;&nbsp;
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblEnabled", "Enabled", ChkEnabled, true)%></td>
                        <td>
                            <asp:CheckBox ID="ChkEnabled" runat="server" Enabled="true" />
                        </td>
                    </tr>                    
                    <tr>
                        <td class="key"><%=base.GetLabel("LblTitle", "Title", null, true)%></td>
                        <td>
                            <asp:Panel runat="server" ID="PanelTitle"></asp:Panel>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblAlias", "Alias", TxtAlias, true)%></td>
                        <td>
                            <asp:TextBox ID="TxtAlias" runat="server" CssClass="adminMediumText"></asp:TextBox>
                            <asp:RequiredFieldValidator ID="ReqAlias" ControlToValidate="TxtAlias" runat="server" Text="*"></asp:RequiredFieldValidator>
                        </td>
                    </tr>                    
                    <tr>
                        <td class="key"><%=base.GetLabel("LblItemDate", "Item date", TxtItemDate, true)%></td>
                        <td class="calendar">
                            <asp:TextBox ID="TxtItemDate" runat="server" CssClass='adminSmallText'></asp:TextBox>        
                            <cc1:CalendarExtender ID="CalItemDate" runat="server"
                                TargetControlID="TxtItemDate" Format="dd/MM/yyyy"></cc1:CalendarExtender>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblValidFrom", "Valid from", TxtValidFrom, true)%></td>
                        <td class="calendar">
                            <asp:TextBox ID="TxtValidFrom" runat="server" CssClass='adminSmallText'></asp:TextBox>        
                            <cc1:CalendarExtender ID="CalValidFrom" runat="server"
                                TargetControlID="TxtValidFrom" Format="dd/MM/yyyy"></cc1:CalendarExtender>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblValidTo", "Valid to", TxtValidTo, true)%></td>
                        <td class="calendar">
                            <asp:TextBox ID="TxtValidTo" runat="server" CssClass='adminSmallText'></asp:TextBox>        
                            <cc1:CalendarExtender ID="CalValidTo" runat="server"
                                TargetControlID="TxtValidTo" Format="dd/MM/yyyy"></cc1:CalendarExtender>
                        </td>
                    </tr>
                    
                    <tr>
                        <td class="key"><%=base.GetLabel("LblDescription", "Description", null, true)%></td>
                        <td>
                            <asp:Panel runat="server" ID="PanelDescription"></asp:Panel>
                        </td>
                    </tr>
                    </table>
                </fieldset>
            </div>
            
            <div class="col width-40">
                
                <fieldset class="adminForm recordInfo">
                    <legend><%=base.GetLabel("LblRecordInfo", "Record info") %></legend>
                    <table class="adminTable" cellspacing="0">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblRecordId", "ID") %></td>
                        <td><asp:Label ID="LblId" runat="server" Text=""></asp:Label></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblCreated", "Created") %></td>
                        <td><asp:Label ID="LblCreated" runat="server" Text=""></asp:Label></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblLastUpdate", "Last update") %></td>
                        <td><asp:Label ID="LblUpdated" runat="server" Text=""></asp:Label></td>
                    </tr>
                    </table>
                </fieldset>
                
                <fieldset class="adminForm">
                    <uc1:PermissionsControl ID="PermissionsControl1" runat="server" />
                </fieldset>                
                
                <fieldset class="adminForm">
                    <legend><%=base.GetLabel("LblFields", "Fields", null, true) %></legend>
                    <uc1:ItemParams ID="ItemFields1" runat="server" />
                </fieldset>                
                
                <fieldset class="adminForm">
                    <legend><%=base.GetLabel("LblParameters", "Parameters", null, true) %></legend>
                    <uc1:ItemParams ID="ItemParams1" runat="server" />
                </fieldset>
            </div>
            <div class="clear"/>
        </asp:View>
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>