using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Web.Caching;
using PigeonCms;
using System.Collections.Generic;
using System.Text;

public partial class Modules_RoomItem : PigeonCms.ItemControl<Item, ItemsFilter>
{
    public StringBuilder LitItem = new StringBuilder();
    public StringBuilder LitPrice = new StringBuilder();
    public StringBuilder LitDefaultImage = new StringBuilder();
    public StringBuilder LitImages = new StringBuilder();
    public StringBuilder PathString = new StringBuilder();


    protected new void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        RoomItem currItem = new RoomItemsManager(true).GetByKey(base.CurrItem.Id);

        if (currItem.CategoryId > 0)
        {
            Category cat = new CategoriesManager().GetByKey(currItem.CategoryId);
            //PathString.Append(new SectionsManager().GetByKey(cat.SectionId).Title + " > " + cat.Title);
            PathString.Append(cat.Title);
            PathString.Append(" > " + currItem.Title);
        }

        if (!string.IsNullOrEmpty(currItem.DefaultImage.FileName))
        {
            LitDefaultImage.Append("<a class='" + BaseModule.CssClass + "' rel='item' "
            + "href='" + currItem.DefaultImage.FileUrl + "' "
            + "title='" + currItem.DefaultImage.Title + "' rel='product'>"
            + "<img id='" + BaseModule.CssClass + "' src='" + VirtualPathUtility.ToAbsolute("~/") + "Handlers/ImageHandler.ashx?size=l&imageUrl=" + currItem.DefaultImage.FileUrl + "' "
            + "alt='" + currItem.DefaultImage.Title + "' class='" + BaseModule.CssClass + "' /></a>");
        }

        int counter = 0;
        //foreach (EmbeddedImage img in currItem.ImagesNotDefault)
        LitImages.Append("<ul class='" + BaseModule.CssClass + "'>");
        foreach (FileMetaInfo img in currItem.Images)
        {
            LitImages.Append("<li class='" + BaseModule.CssClass + "'><a class='" + BaseModule.CssClass + "' href='" + img.FileUrl + "' title='" + img.Title + "' rel='product'>");
            LitImages.Append("<img id='bigPicture" + counter.ToString() + "' src='" + VirtualPathUtility.ToAbsolute("~/")
                + "Handlers/ImageHandler.ashx?size=m&imageUrl=" + img.FileUrl + "' " +
                "alt='" + img.Title + "' style='' class='" + BaseModule.CssClass + "' />");
            LitImages.Append("</a></li>");

            counter++;
        }
        LitImages.Append("</ul>");

        //LitItem.Append("<h2>" + currItem.Title + "</h2>");
        LitItem.Append(currItem.Description);
        //LitPrice.Append(base.GetLabel("LblPrice", "Prezzo") + ": " + currItem.Price + " " + base.GetLabel("LblCurrency", ""));
    }
}
