<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_ItemsAdmin" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="cc1" %>
<%@ Register src="~/Controls/ItemParams.ascx" tagname="ItemParams" tagprefix="uc1" %>
<%@ Register src="~/Controls/PermissionsControl.ascx" tagname="PermissionsControl" tagprefix="uc1" %>
<%@ Register src="~/Controls/ContentEditorControl.ascx" tagname="ContentEditorControl" tagprefix="uc1" %>

<script type="text/javascript">
// <!CDATA[

function preloadAlias(sourceControlName, targetControl) {
    var res = document.getElementById(sourceControlName).value;
    if (targetControl.value == "") {
        res = res.toLowerCase();
        res = res.replace(/\ /g, '-');    //replace all occurs
        targetControl.value = res;
    }
}

function pageLoad(sender, args) {
    $(document).ready(function () {
        $("a.fancyRefresh").fancybox({
            'width': '80%',
            'height': '80%',
            'type': 'iframe',
            'hideOnContentClick': false,
            onClosed: function () {
                RemoveFromCache(onSuccess, onFailure);
                ReloadUpd1();
            }
        });

        $('td.key').each(function () {
            var hide = true;
            var html = $(this).html();
            if ($.trim(html) != '')
                hide = false;
            if (hide)
                $(this).parent('tr').hide();
        });

    });
}

var upd1 = '<%=Upd1.ClientID%>';

function ReloadUpd1() {
    if (upd1 != null) {
        __doPostBack(upd1, 'items');
    }
}

var deleteQuestion = '<%=PigeonCms.Utility.GetLabel("RECORD_DELETE_QUESTION") %>';

//use in popup version
function closePopup() {
    parent.$.fancybox.close();
}

function onSuccess(result) { }
function onFailure(result) { }
// ]]>
</script>

<asp:ScriptManager ID="ScriptManager1" runat="server" EnablePageMethods="true"></asp:ScriptManager>
<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>

<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>

    <asp:Label ID="LblErr" runat="server" Text="" CssClass="error"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>

    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0" OnActiveViewChanged="MultiView1_ActiveViewChanged">

        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar">
                <%=PigeonCms.Utility.GetLabel("LblCreateNew", "Create new", DropNew)%>&nbsp;
                <asp:DropDownList runat="server" ID="DropNew"  AutoPostBack="true" CssClass="adminMediumText" 
                OnSelectedIndexChanged="DropNew_SelectedIndexChanged">
                </asp:DropDownList>
                <asp:Button ID="BtnNew" runat="server" Text="<%$ Resources:PublicLabels, CmdNew %>" Visible="false" CssClass="button" OnClick="BtnNew_Click" />
            </div>
            <fieldset class="adminFilters">
                <%=PigeonCms.Utility.GetLabel("LblFilters", "Filters") %>&nbsp;
                <asp:DropDownList ID="DropEnabledFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropEnabledFilter_SelectedIndexChanged">
                </asp:DropDownList>
                <asp:DropDownList ID="DropSectionsFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropSectionsFilter_SelectedIndexChanged">
                </asp:DropDownList>
                <asp:DropDownList ID="DropCategoriesFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropCategoriesFilter_SelectedIndexChanged">
                </asp:DropDownList>
                <asp:DropDownList ID="DropItemTypesFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropItemTypesFilter_SelectedIndexChanged">
                </asp:DropDownList>
            </fieldset>
            <br />
            <asp:GridView ID="Grid1" runat="server" AllowPaging="True" AllowSorting="true" Width="100%" AutoGenerateColumns="False"
                DataSourceID="ObjDs1" DataKeyNames="Id" OnRowCommand="Grid1_RowCommand" OnRowCreated="Grid1_RowCreated" OnRowDataBound="Grid1_RowDataBound">
                <Columns>
                    <asp:TemplateField ItemStyle-Width="10" Visible="false">
                        <ItemTemplate>
                        <asp:ImageButton ID="ImgSel" CommandName="Select" CommandArgument='<%#Eval("Id") %>' 
                        runat="server" SkinID="ImgEditFile" />
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField HeaderText="<%$ Resources:PublicLabels, LblTitle %>" ItemStyle-HorizontalAlign="Left" HeaderStyle-HorizontalAlign="Left">
                        <ItemTemplate>
                            <asp:LinkButton ID="LnkTitle" runat="server" CausesValidation="false" CommandName="Select" CommandArgument='<%#Eval("Id") %>'></asp:LinkButton>
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:BoundField DataField="Alias" HeaderText="Alias" SortExpression="Alias" />

                    <asp:TemplateField HeaderText="<%$ Resources:PublicLabels, LblSection %>" ItemStyle-HorizontalAlign="Left" HeaderStyle-HorizontalAlign="Left">
                        <ItemTemplate>
                            <asp:Literal ID="LitSectionTitle" runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField HeaderText="<%$ Resources:PublicLabels, LblCategory %>" ItemStyle-HorizontalAlign="Left" HeaderStyle-HorizontalAlign="Left">
                        <ItemTemplate>
                            <asp:Literal ID="LitCategoryTitle" runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:BoundField DataField="ItemTypeName" HeaderText="<%$ Resources:PublicLabels, LblType %>" />

                    <asp:TemplateField ItemStyle-HorizontalAlign="Right" ItemStyle-BorderStyle="None" ItemStyle-Width="25" SortExpression="Ordering">
                        <ItemTemplate>
                            <asp:ImageButton ID="ImgMoveUp" CommandName="MoveUp" CommandArgument='<%#Eval("Id") %>'
                            SkinID="ImgSortAsc" runat="server" />
                            <asp:ImageButton ID="ImgMoveDown" CommandName="MoveDown" CommandArgument='<%#Eval("Id") %>'
                            SkinID="ImgSortDesc" runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="Ordering" HeaderText="<%$ Resources:PublicLabels, LblOrder %>" SortExpression="Ordering" ItemStyle-HorizontalAlign="Right" />

                        
                    <asp:TemplateField HeaderText="<%$ Resources:PublicLabels, LblEnabled %>" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                            <asp:ImageButton runat="server" ID="ImgEnabledOk" CommandName="ImgEnabledOk" CommandArgument='<%#Eval("Id") %>' SkinID="ImgOk" Visible="false" />
                            <asp:ImageButton runat="server" ID="ImgEnabledKo" CommandName="ImgEnabledKo" CommandArgument='<%#Eval("Id") %>' SkinID="ImgUnchecked" Visible="false" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Access type" SortExpression="AccessType">
                        <ItemTemplate>
                        <asp:Literal ID="LitAccessTypeDesc" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Access Level" SortExpression="AccessCode, AccessLevel">
                        <ItemTemplate>
                        <asp:Literal ID="LitAccessLevel" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField HeaderText="<%$ Resources:PublicLabels, LblFiles %>" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                            <asp:HyperLink runat="server" ID="LnkUploadFiles">
                                <asp:Image ID="FilesUpload" runat="server" SkinID="ImgUpload" AlternateText="Gestione files" Visible="true" ToolTip="Gestione files" />
                            </asp:HyperLink>
                            <br />
                            <span><asp:Literal ID="LitFilesCount" runat="server" Text=""></asp:Literal></span>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="<%$ Resources:PublicLabels, LblImages %>" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                            <asp:HyperLink runat="server" ID="LnkUploadImg">
                                <asp:Image ID="ImgUpload" runat="server" SkinID="ImgUpload" AlternateText="Gestione immagini" Visible="true" ToolTip="Gestione immagini" />
                            </asp:HyperLink>
                            <br />
                            <span><asp:Literal ID="LitImgCount" runat="server" Text=""></asp:Literal></span>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="" ItemStyle-HorizontalAlign="Center" ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkDel" CommandName="DeleteRow" CommandArgument='<%#Eval("Id") %>' 
                        runat="server" SkinID="ImgDelFile" 
                        OnClientClick="return confirm(deleteQuestion);"  />
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:BoundField DataField="Id" HeaderText="ID" SortExpression="Id" ItemStyle-HorizontalAlign="Right" HeaderStyle-HorizontalAlign="Right" />
                </Columns>
            </asp:GridView>
            
            <asp:ObjectDataSource ID="ObjDs1" runat="server" 
                SortParameterName="sort" SelectMethod="GetByFilter" 
                TypeName="PigeonCms.ItemsManager`2[[PigeonCms.Item],[PigeonCms.ItemsFilter]]" 
                OnObjectCreating="ObjDs1_ObjectCreating"
                OnSelecting="ObjDs1_Selecting">
                <SelectParameters>
                    <asp:Parameter Name="filter" Type="Object" />
                    <asp:Parameter Name="sort" Type="String" DefaultValue="" />
                </SelectParameters>
                <DeleteParameters>
                    <asp:Parameter Name="Id" Type="Int32" />
                </DeleteParameters>
            </asp:ObjectDataSource>
        </asp:View>
   

        <asp:View ID="ViewInsert" runat="server">
        
            <div class="adminToolbar">
                <asp:Button ID="BtnSave" runat="server" Text="<%$ Resources:PublicLabels, CmdSave %>" CssClass="button" OnClick="BtnSave_Click" />
                <asp:Button ID="BtnCancel" runat="server" Text="<%$ Resources:PublicLabels, CmdCancel %>" CssClass="button" CausesValidation="false" OnClick="BtnCancel_Click" />
            </div>
            
            <div class="col width-60">
                <fieldset class="adminForm">
                    <legend></legend>
                    <table class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblItemType", "Item type", LitItemType, true)%></td>
                        <td colspan="3">
                            <asp:Literal ID="LitItemType" runat="server"></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblCategory", "Category", DropCategories, true)%></td>
                        <td style="width: 500px">
                            <asp:DropDownList ID="DropCategories" runat="server" CssClass="adminMediumText"></asp:DropDownList>&nbsp;&nbsp;&nbsp;
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblEnabled", "Enabled", ChkEnabled, true)%></td>
                        <td>
                            <asp:CheckBox ID="ChkEnabled" runat="server" Enabled="true" />
                        </td>
                    </tr>                    
                    <tr>
                        <td class="key"><%=base.GetLabel("LblTitle", "Title", null, true)%></td>
                        <td>
                            <asp:Panel runat="server" ID="PanelTitle"></asp:Panel>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblAlias", "Alias", TxtAlias, true)%></td>
                        <td>
                            <asp:TextBox ID="TxtAlias" runat="server" CssClass="adminMediumText"></asp:TextBox>
                            <asp:RequiredFieldValidator ID="ReqAlias" ControlToValidate="TxtAlias" runat="server" Text="*"></asp:RequiredFieldValidator>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblCssClass", "Css class", TxtCssClass, true)%></td>
                        <td>
                            <asp:TextBox ID="TxtCssClass" runat="server" MaxLength="50" CssClass="adminMediumText"></asp:TextBox>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblItemDate", "Item date", TxtItemDate, true)%></td>
                        <td class="calendar">
                            <asp:TextBox ID="TxtItemDate" runat="server" CssClass='adminSmallText'></asp:TextBox>        
                            <cc1:CalendarExtender ID="CalItemDate" runat="server"
                                TargetControlID="TxtItemDate" Format="dd/MM/yyyy"></cc1:CalendarExtender>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblValidFrom", "Valid from", TxtValidFrom, true)%></td>
                        <td class="calendar">
                            <asp:TextBox ID="TxtValidFrom" runat="server" CssClass='adminSmallText'></asp:TextBox>        
                            <cc1:CalendarExtender ID="CalValidFrom" runat="server"
                                TargetControlID="TxtValidFrom" Format="dd/MM/yyyy"></cc1:CalendarExtender>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblValidTo", "Valid to", TxtValidTo, true)%></td>
                        <td class="calendar">
                            <asp:TextBox ID="TxtValidTo" runat="server" CssClass='adminSmallText'></asp:TextBox>        
                            <cc1:CalendarExtender ID="CalValidTo" runat="server"
                                TargetControlID="TxtValidTo" Format="dd/MM/yyyy"></cc1:CalendarExtender>
                        </td>
                    </tr>
                    
                    <tr>
                        <td class="key"><%=base.GetLabel("LblDescription", "Description", null, true)%></td>
                        <td>
                            <asp:Panel runat="server" ID="PanelDescription"></asp:Panel>
                        </td>
                    </tr>
                    </table>
                </fieldset>
            </div>
            
            <div class="col width-40">
                
                <fieldset class="adminForm recordInfo">
                    <legend><%=base.GetLabel("LblRecordInfo", "Record info") %></legend>
                    <table class="adminTable" cellspacing="0">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblRecordId", "ID") %></td>
                        <td><asp:Label ID="LblId" runat="server" Text=""></asp:Label></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblCreated", "Created") %></td>
                        <td><asp:Label ID="LblCreated" runat="server" Text=""></asp:Label></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblLastUpdate", "Last update") %></td>
                        <td><asp:Label ID="LblUpdated" runat="server" Text=""></asp:Label></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblOrderId", "Order Id") %></td>
                        <td><asp:Label ID="LblOrderId" runat="server" Text=""></asp:Label></td>
                    </tr>
                    </table>
                </fieldset>
                
                <fieldset class="adminForm">
                    <uc1:PermissionsControl ID="PermissionsControl1" runat="server" />
                </fieldset>                
                
                <fieldset class="adminForm">
                    <uc1:ItemParams ID="ItemFields1" runat="server" />
                </fieldset>                
                
                <fieldset class="adminForm">
                    <uc1:ItemParams ID="ItemParams1" runat="server" />
                </fieldset>
            </div>
            <div class="clear"/>
        </asp:View>
    
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>