<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_Default" %>

<asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>

<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>
    <asp:Label ID="LblErr" runat="server" Text="" CssClass="error"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>

    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0" OnActiveViewChanged="MultiView1_ActiveViewChanged">

        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar">
               <asp:Button ID="BtnNew" runat="server" Text="Nuovo" CssClass="button" OnClick="BtnNew_Click" />
            </div>
            <fieldset class="adminFilters">
                <%=base.GetLabel("LblFilters", "Filters")%>&nbsp;
                <asp:DropDownList ID="DropModuleTypesFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropModuleTypesFilter_SelectedIndexChanged">
                </asp:DropDownList>
            </fieldset>
            <br />
            <asp:GridView ID="Grid1" runat="server" AllowPaging="True" AllowSorting="true" Width="100%" AutoGenerateColumns="False"
                DataSourceID="ObjDs1" DataKeyNames="ResourceId" OnRowCommand="Grid1_RowCommand" OnRowCreated="Grid1_RowCreated" OnRowDataBound="Grid1_RowDataBound">
                <Columns>
                    <asp:TemplateField ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkSel" CommandName="Select" CommandArgument='<%#Eval("ResourceId") %>' 
                        runat="server" SkinID="ImgEditFile" />                
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:BoundField DataField="ResourceSet" HeaderText="Resource" SortExpression="" />
                    <asp:BoundField DataField="ResourceId" HeaderText="Id" SortExpression="" />
                    
                    <asp:TemplateField HeaderText="Values">
                        <ItemTemplate>
                        <asp:Literal ID="LitValue" runat="server"  />                
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Cancella" ItemStyle-HorizontalAlign="Center" ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkDel" CommandName="DeleteRow" CommandArgument='<%#Eval("ResourceId") %>' 
                        runat="server" SkinID="ImgDelFile" 
                        OnClientClick="return confirm('Cancellare la riga?');"  />
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                </Columns>
            </asp:GridView>
            
            <asp:ObjectDataSource ID="ObjDs1" runat="server" SortParameterName="sort" SelectMethod="GetLabelTransByFilter" 
                TypeName="PigeonCms.LabelsManager" OnSelecting="ObjDs1_Selecting">
                <SelectParameters>
                    <asp:Parameter Name="filter" Type="Object" />
                    <asp:Parameter Name="sort" Type="String" DefaultValue="" />
                </SelectParameters>
                <DeleteParameters>
                    <%--<asp:Parameter Name="Comment" Type="String" />--%>
                </DeleteParameters>
            </asp:ObjectDataSource>
        </asp:View>
   

        <asp:View ID="ViewInsert" runat="server">
        
            <div class="adminToolbar">
                <asp:Button ID="BtnSave" runat="server" Text="<%$ Resources:PublicLabels, CmdSave %>" CssClass="button" OnClientClick="MyObject.UpdateEditorFormValue();" OnClick="BtnSave_Click" />
                <asp:Button ID="BtnCancel" runat="server" Text="<%$ Resources:PublicLabels, CmdCancel %>" CssClass="button" OnClick="BtnCancel_Click" />
            </div>
            
            <div class="col width-100">
                
                <fieldset class="adminForm">
                    <legend></legend>
                    <table class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblResourceSet", "Resource set") %></td>
                        <td colspan="3">
                            <asp:Literal ID="LitResourceSet" runat="server"></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblResourceId", "Resource id", TxtResourceId) %></td>
                        <td colspan="3">
                            <asp:TextBox ID="TxtResourceId" runat="server" CssClass="adminText"></asp:TextBox></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblValue", "Value") %></td>
                        <td>
                            <asp:Panel runat="server" ID="PanelValue"></asp:Panel>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblComment", "Comment") %></td>
                        <td>
                            <asp:Panel runat="server" ID="PanelComment"></asp:Panel>
                        </td>
                    </tr>
                    </table>
                </fieldset>
                
            </div>
            
            <div class="clear"/>
        </asp:View>
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>