<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_Default" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="cc1" %>

<asp:ScriptManager ID="ScriptManager1" EnablePartialRendering="true" runat="server"></asp:ScriptManager>
<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>

<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>
    
    <asp:Label ID="LblErr" runat="server" Text="" CssClass="error"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>
    
    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0" OnActiveViewChanged="MultiView1_ActiveViewChanged">
    
        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar" style="visibility:hidden;"></div>
            <fieldset title="Filtri">
                    <%=PigeonCms.Utility.GetLabel("LblFilters")%>&nbsp;
                    <asp:DropDownList runat="server" ID="DropTopRowsFilter" AutoPostBack="true" CssClass="adminMediumText" 
                        OnSelectedIndexChanged="Filter_Changed">
                        </asp:DropDownList>

                    <asp:DropDownList runat="server" ID="DropTracerItemTypeFilter" AutoPostBack="true" CssClass="adminSmallText" 
                        OnSelectedIndexChanged="Filter_Changed">
                        </asp:DropDownList>

                    <asp:DropDownList runat="server" ID="DropModuleTypesFilter"  AutoPostBack="true" CssClass="adminMediumText" 
                        OnSelectedIndexChanged="Filter_Changed">
                        </asp:DropDownList>

                    <asp:DropDownList runat="server" ID="DropDatesRangeFilter" AutoPostBack="true" CssClass="adminSmallText" 
                        OnSelectedIndexChanged="Filter_Changed">
                        </asp:DropDownList>

                    <asp:TextBox ID="TxtIpFilter" runat="server" AutoPostBack="true" CssClass="adminSmallText" 
                        ontextchanged="Filter_Changed"></asp:TextBox>
                    <cc1:TextBoxWatermarkExtender ID="WaterIpFilter" TargetControlID="TxtIpFilter" runat="server" 
                        WatermarkText="<IP address>" WatermarkCssClass="adminSmallText watermark">
                    </cc1:TextBoxWatermarkExtender>

                    <asp:TextBox ID="TxtSessionIdFilter" runat="server" AutoPostBack="true" CssClass="adminSmallText" 
                        ontextchanged="Filter_Changed"></asp:TextBox>
                    <cc1:TextBoxWatermarkExtender ID="WaterSessionFilter" TargetControlID="TxtSessionIdFilter" runat="server" 
                        WatermarkText="<Session ID>" WatermarkCssClass="adminSmallText watermark">
                    </cc1:TextBoxWatermarkExtender>

                    <asp:TextBox ID="TxtDescriptionFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" 
                        ontextchanged="Filter_Changed"></asp:TextBox>
                    <cc1:TextBoxWatermarkExtender ID="WaterDescriptionFilter" TargetControlID="TxtDescriptionFilter" runat="server" 
                        WatermarkText="<description>" WatermarkCssClass="adminMediumText watermark">
                    </cc1:TextBoxWatermarkExtender>
            </fieldset>
            <br />
            <asp:GridView ID="Grid1" runat="server" Width="100%" AllowPaging="true" 
                AllowSorting="true" AutoGenerateColumns="false" 
                DataSourceID="ObjDs1" DataKeyNames="Id" OnRowCommand="Grid1_RowCommand" 
                OnRowCreated="Grid1_RowCreated" OnRowDataBound="Grid1_RowDataBound" 
                ondatabinding="Grid1_DataBinding">
                <Columns>
                    <asp:TemplateField ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="ImgSel" CommandName="Select" CommandArgument='<%#Eval("Id") %>' 
                            runat="server" SkinID="ImgEditFile" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:BoundField DataField="DateInserted" HeaderText="Date" SortExpression="DateInserted" />

                    <asp:TemplateField HeaderText="IP/Session">
                        <ItemTemplate>
                        <asp:Literal ID="LitIp" runat="server" Text=""></asp:Literal><br />
                        <asp:Literal ID="LitSessionId" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>                    

                    <asp:TemplateField HeaderText="Module">
                        <ItemTemplate>
                        <asp:Literal ID="LitModule" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:BoundField DataField="UserInserted" HeaderText="User" SortExpression="UserInserted" />
                    
                    <asp:TemplateField HeaderText="Url" SortExpression="Url">
                        <ItemTemplate>
                        <asp:Literal ID="LitUrl" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Description">
                        <ItemTemplate>
                        <asp:Literal ID="LitDescription" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>

                    <%--<asp:TemplateField HeaderText="Del" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center" HeaderStyle-Width="25">
                        <ItemTemplate>
                            <asp:ImageButton ID="LnkDel" CommandName="DeleteRow" CommandArgument='<%#Eval("Id") %>' runat="server" 
                                SkinID="ImgDelFile" OnClientClick="return confirm('Cancellare la riga?');"  />
                        </ItemTemplate>
                    </asp:TemplateField>--%>
                    
                    <asp:BoundField DataField="Id" HeaderText="ID" SortExpression="Id" />
                </Columns>
            </asp:GridView>
            
            <asp:ObjectDataSource ID="ObjDs1" runat="server"  SortParameterName="sort" OnSelecting="ObjDs1_Selecting"
                SelectMethod="GetByFilter" TypeName="PigeonCms.LogItemsManager">
                <SelectParameters>
                    <asp:Parameter Name="filter" Type="object" />
                    <asp:Parameter Name="sort" Type="String" />
                </SelectParameters>
                <DeleteParameters>
                    <asp:Parameter Name="Id" Type="Int32" />
                </DeleteParameters>
            </asp:ObjectDataSource>
        </asp:View>
   

        <asp:View ID="ViewInsert" runat="server">
        
            <div class="adminToolbar">
                <asp:Button ID="BtnCancel" runat="server" Text="<%$ Resources:PublicLabels, CmdCancel %>" CssClass="button" OnClick="BtnCancel_Click" />
            </div>
    
            <div class="col width-100">
            
                <fieldset class="adminForm recordInfo">
                <legend><%=base.GetLabel("LblRecordInfo", "Record info") %></legend>
                <table cellspacing="0" class="adminTable">
                    <tr>
                        <td class="key">ID</td>
                        <td><asp:Literal ID="LitId" runat="server" Text=""></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=PigeonCms.Utility.GetLabel("LblCreated", "Created") %></td>
                        <td><asp:Literal ID="LitCreated" runat="server" Text=""></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblType", "Type") %></td>
                        <td colspan="3">
                            <asp:Literal ID="LitType" runat="server"></asp:Literal></td>
                    </tr>
                </table>
                </fieldset>
                            
                <fieldset class="adminForm">
                    <legend><%=PigeonCms.Utility.GetLabel("LblDetails", "Details") %></legend>
                    
                    <table cellspacing="0" class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblModuleType", "Module") %></td>
                        <td colspan="3">
                            <asp:Literal ID="LitModuleType" runat="server"></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblView", "View") %></td>
                        <td colspan="3">
                            <asp:Literal ID="LitView" runat="server"></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblIp", "Ip") %></td>
                        <td colspan="3">
                            <asp:Literal ID="LitUserHostAddress" runat="server"></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblSessionId", "Session ID") %></td>
                        <td colspan="3">
                            <asp:Literal ID="LitSessionId" runat="server"></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblUser", "User") %></td>
                        <td colspan="3">
                            <asp:Literal ID="LitUserInserted" runat="server"></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblUrl", "Url") %></td>
                        <td colspan="3">
                            <asp:Literal ID="LitUrl" runat="server"></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblDescription", "Description") %></td>
                        <td colspan="3">
                            <asp:Literal ID="LitDescription" runat="server"></asp:Literal></td>
                    </tr>
                    </table>
                </fieldset>
            </div>
            
            <div class="clear"/>
        </asp:View>
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>