<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_MenuAdmin" %>
<%@ Register src="~/Controls/ModuleParams.ascx" tagname="ModuleParams" tagprefix="uc1" %>
<%@ Register src="~/Controls/PermissionsControl.ascx" tagname="PermissionsControl" tagprefix="uc1" %>

<asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>

<script type="text/javascript">
function preloadTitle(sourceControlName, targetControl)
{
    if (targetControl.value == "")
        targetControl.value = document.getElementById(sourceControlName).value;
}

function preloadAlias(sourceControlName, targetControl)
{
    var res = document.getElementById(sourceControlName).value;
    if (targetControl.value == "")
    {
        res = res.toLowerCase();
        res = res.replace(/\ /g,'-');    //replace all occurs
        targetControl.value = res;
    }
}

function changeModueleTypes() {
    var elemname = '#<%=DropModuleTypes.ClientID %>';
    $(elemname).removeAttr('disabled');
    $(elemname).removeClass('locked');
    $('#lnkchange').hide();
}

function changeView() {
    var elemname = '#<%=DropViews.ClientID %>';
    $(elemname).removeAttr('disabled');
    $(elemname).removeClass('locked');
    $('#lnkChangeView').hide();
}

function pageLoad(sender, args) {
    $("div.fancy a").fancybox({
        'width': '80%',
        'height': '80%',
        'type': 'iframe',
        'hideOnContentClick': false,
        onClosed: function() { }
    });
}
</script>

<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>
    
    <asp:Label ID="LblErr" runat="server" Text="" CssClass="error"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>
    
    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0" OnActiveViewChanged="MultiView1_ActiveViewChanged">
    
        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar">
                <%=PigeonCms.Utility.GetLabel("LblCreateNew", "Create new", DropNewItem)%>&nbsp;
                <asp:DropDownList runat="server" ID="DropNewItem"  AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropNewItem_SelectedIndexChanged">
                </asp:DropDownList>
            </div>
            <fieldset class="adminFilters">
                <%=PigeonCms.Utility.GetLabel("LblFilters")%>&nbsp;
                <asp:DropDownList ID="DropMenuTypesFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropMenuTypesFilter_SelectedIndexChanged"></asp:DropDownList>
                <asp:DropDownList ID="DropPublishedFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropPublishedFilter_SelectedIndexChanged"></asp:DropDownList>
                <asp:DropDownList ID="DropMasterPageFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropMasterPageFilter_SelectedIndexChanged"></asp:DropDownList>
                <asp:DropDownList ID="DropModuleTypesFilter" runat="server" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropModuleTypesFilter_SelectedIndexChanged"></asp:DropDownList>
            </fieldset>
            <br />
            <asp:GridView ID="Grid1" runat="server" Width="100%" AllowPaging="True" AllowSorting="false" AutoGenerateColumns="False"
                DataSourceID="ObjDs1" DataKeyNames="Id"  OnRowCommand="Grid1_RowCommand" OnRowCreated="Grid1_RowCreated" OnRowDataBound="Grid1_RowDataBound">
                <Columns>
                    <asp:TemplateField ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkSel" CommandName="Select" CommandArgument='<%#Eval("Id") %>' 
                            runat="server" SkinID="ImgEditFile" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="MenuType" Visible="false" HeaderText="MenuType" SortExpression="MenuType" />
                    <asp:TemplateField HeaderText="Name" SortExpression="Name">
                        <ItemTemplate>
                        <asp:Literal ID="LitName" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>                    
                    <asp:BoundField DataField="Title" HeaderText="Titolo" SortExpression="Title" Visible="false" />
                    
                    <asp:TemplateField HeaderText="Alias" SortExpression="Alias">
                        <ItemTemplate>
                        <asp:Literal ID="LitAlias" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:BoundField DataField="CssClass" HeaderText="Css Class" SortExpression="CssClass" />
                    <asp:BoundField DataField="CurrThemeStored" HeaderText="Theme" SortExpression="CurrThemeStored" />
                    <asp:BoundField DataField="CurrMasterpageStored" HeaderText="Masterpage" SortExpression="CurrMasterpageStored" />
                    
                    <asp:TemplateField HeaderText="Module name">
                        <ItemTemplate>
                        <asp:Literal ID="LitModuleNameDesc" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField ItemStyle-Width="10" ItemStyle-HorizontalAlign="Center" HeaderText="Module content">
                        <ItemTemplate>
                            <div class="fancy">
                            <asp:HyperLink runat="server" ID="LnkModuleContent" Visible="false">
                            <asp:Image ID="ImgAttribute" runat="server" SkinID="ImgAttributes" AlternateText="" Visible="true" />
                            </asp:HyperLink>
                            </div>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Visible" ItemStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                            <asp:ImageButton runat="server" ID="ImgVisibleOk" CommandName="ImgVisibleOk" CommandArgument='<%#Eval("Id") %>' SkinID="ImgOk" Visible="false" />
                            <asp:ImageButton runat="server" ID="ImgVisibleKo" CommandName="ImgVisibleKo" CommandArgument='<%#Eval("Id") %>' SkinID="ImgUnchecked" Visible="false" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField HeaderText="Published" ItemStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                            <asp:ImageButton runat="server" ID="ImgPublishedOk" CommandName="ImgPublishedOk" CommandArgument='<%#Eval("Id") %>' SkinID="ImgOk" Visible="false" />
                            <asp:ImageButton runat="server" ID="ImgPublishedKo" CommandName="ImgPublishedKo" CommandArgument='<%#Eval("Id") %>' SkinID="ImgUnchecked" Visible="false" />
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField HeaderText="Access type">
                        <ItemTemplate>
                        <asp:Literal ID="LitAccessTypeDesc" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Access Level" SortExpression="AccessCode, AccessLevel">
                        <ItemTemplate>
                        <asp:Literal ID="LitAccessLevel" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField ItemStyle-HorizontalAlign="Right" ItemStyle-Width="25" ItemStyle-BorderStyle="None">
                        <ItemTemplate>
                            <asp:ImageButton ID="ImgMoveUp" CommandName="MoveUp" CommandArgument='<%#Eval("Id") %>'
                            SkinID="ImgSortAsc" runat="server" />
                            <asp:ImageButton ID="ImgMoveDown" CommandName="MoveDown" CommandArgument='<%#Eval("Id") %>'
                            SkinID="ImgSortDesc" runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="Ordering" HeaderText="Order" SortExpression="Ordering" ItemStyle-HorizontalAlign="Right" />

                    <asp:TemplateField HeaderText="Copy" Visible="true" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center" HeaderStyle-Width="25">
                        <ItemTemplate>
                            <asp:ImageButton ID="LnkCopy" CommandName="CopyRow" CommandArgument='<%#Eval("Id") %>' runat="server" 
                                SkinID="ImgCopy" />
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField HeaderText="Use SSL" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                            <asp:Image runat="server" ID="ImgUseSsl" SkinID="ImgSecurity" Visible="false" />
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField HeaderText="Core" SortExpression="IsCore" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                        <asp:CheckBox Enabled="false" Checked='<%#Eval("IsCore") %>' runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>                    
                    
                    <asp:TemplateField HeaderText="Del" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center" HeaderStyle-Width="25">
                        <ItemTemplate>
                            <asp:ImageButton ID="LnkDel" CommandName="DeleteRow" CommandArgument='<%#Eval("Id") %>' runat="server" 
                                SkinID="ImgDelFile" OnClientClick="return confirm('Cancellare la riga?');"  />
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:BoundField DataField="Id" HeaderText="ID" SortExpression="Id" />
                </Columns>
            </asp:GridView>
            
            <asp:ObjectDataSource ID="ObjDs1" runat="server" SortParameterName="" OnSelecting="ObjDs1_Selecting"
                SelectMethod="GetTree" TypeName="PigeonCms.MenuManager">
                <SelectParameters>
                    <asp:Parameter Name="filter" Type="object" />
                    <asp:Parameter Name="level" Type="Int32" DefaultValue="-1" />
                    <asp:Parameter Name="separatorText" Type="String" DefaultValue="--" />
                </SelectParameters>
                <DeleteParameters>
                    <asp:Parameter Name="Id" Type="Int32" />
                </DeleteParameters>
            </asp:ObjectDataSource>
        </asp:View>
   

        <asp:View ID="ViewInsert" runat="server">

            <div class="adminToolbar">
                <asp:Button ID="BtnSave" runat="server" Text="<%$ Resources:PublicLabels, CmdSave %>" CssClass="button" OnClick="BtnSave_Click" />
                <asp:Button ID="BtnApply" runat="server" Text="<%$ Resources:PublicLabels, CmdApply %>" CssClass="button" OnClick="BtnApply_Click" />
                <asp:Button ID="BtnCancel" CausesValidation="false" runat="server" Text="<%$ Resources:PublicLabels, CmdCancel %>" CssClass="button" OnClick="BtnCancel_Click" />
            </div>
            
            <div class="col width-50">
                <fieldset class="adminForm">
                <legend><%=base.GetLabel("LblDetails", "Details") %></legend>
                <table cellspacing="0" class="adminTable">
                <tr>
                    <td class="key"><%=base.GetLabel("LblMenuType", "Menu type", LitMenuType, true)%></td>
                    <td><asp:Literal ID="LitMenuType" runat="server"></asp:Literal></td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblContentType", "Content type", DropModuleTypes, true)%></td>
                    <td>
                        <asp:DropDownList ID="DropModuleTypes" CssClass="adminMediumText locked" runat="server"
                        AutoPostBack="true" OnSelectedIndexChanged="DropModuleTypes_SelectedIndexChanged"></asp:DropDownList>
                        <a href="javascript:void(0)" onclick="changeModueleTypes();" id="lnkchange" runat="server">
                        <%=base.GetLabel("LblChange", "change", null, true) %>
                        </a>
                    </td>
                </tr>                
                <tr>
                    <td class="key"><%=base.GetLabel("LblName", "Name", TxtName, true)%></td>
                    <td>
                        <asp:TextBox ID="TxtName" MaxLength="200" runat="server" CssClass="adminMediumText"></asp:TextBox>
                        <asp:RequiredFieldValidator ID="ReqName" ControlToValidate="TxtName" runat="server" Text="*"></asp:RequiredFieldValidator>
                    </td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblTitle", "Title", null, true)%></td>
                    <td>
                        <asp:Panel runat="server" ID="PanelTitle"></asp:Panel>
                    </td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblTitleWindow", "Window's title", null, true)%></td>
                    <td>
                        <asp:Panel runat="server" ID="PanelTitleWindow"></asp:Panel>
                    </td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblAlias", "Alias", TxtAlias, true)%></td>
                    <td>
                        <asp:TextBox ID="TxtAlias" Rows="3" runat="server" CssClass="adminMediumText"></asp:TextBox>
                        <asp:RequiredFieldValidator ID="ReqAlias" ControlToValidate="TxtAlias" runat="server" Text="*"></asp:RequiredFieldValidator>
                    </td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblRoute", "Route", DropRouteId, true)%></td>
                    <td>
                        <asp:DropDownList ID="DropRouteId" CssClass="adminMediumText" runat="server">
                        </asp:DropDownList>
                    </td>
                </tr>                
                <tr>
                    <td class="key"><%=base.GetLabel("LblLink", "Link", TxtLink, true)%></td>
                    <td>
                        <asp:TextBox ID="TxtLink" MaxLength="200" runat="server" CssClass="adminMediumText"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblRedirectTo", "Redirect to", DropReferMenuId, true)%></td>
                    <td>
                        <asp:DropDownList ID="DropReferMenuId" CssClass="adminMediumText" runat="server">
                        </asp:DropDownList>
                    </td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblParentItem", "Parent item", ListParentId, true)%></td>
                    <td>
                        <asp:ListBox ID="ListParentId" SelectionMode="Single" Rows="18" runat="server" CssClass="adminMediumText">
                        </asp:ListBox>
                    </td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblCssClass", "Css class", TxtCssClass, true)%></td>
                    <td>
                        <asp:TextBox ID="TxtCssClass" MaxLength="50" runat="server" CssClass="adminMediumText"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblUseSsl", "Use SSL", DropUseSsl, true)%></td>
                    <td>
                        <asp:DropDownList ID="DropUseSsl" runat="server" CssClass="adminMediumText">
                            <asp:ListItem Value="2" Text="Use route settings"></asp:ListItem>
                            <asp:ListItem Value="0" Text="No"></asp:ListItem>
                            <asp:ListItem Value="1" Text="Yes"></asp:ListItem>
                        </asp:DropDownList>
                    </td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblTheme", "Theme", DropCurrTheme, true)%></td>
                    <td>
                        <asp:DropDownList ID="DropCurrTheme" CssClass="adminMediumText" runat="server">
                        </asp:DropDownList>
                    </td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblMasterpage", "Masterpage", DropCurrMasterPage, true)%></td>
                    <td>
                        <asp:DropDownList ID="DropCurrMasterPage" CssClass="adminMediumText" runat="server">
                        </asp:DropDownList>
                    </td>
                </tr>
                </table>
                </fieldset>
                
                <fieldset class="adminForm">
                    <legend><%=base.GetLabel("LblOptions", "Options") %></legend>
                    
                    <table cellspacing="0" class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblVisible", "Visible", ChkVisible, true)%></td>
                        <td>
                            <asp:CheckBox ID="ChkVisible" runat="server" Enabled="true" />
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblPublished", "Published", ChkPublished, true)%></td>
                        <td>
                            <asp:CheckBox ID="ChkPublished" runat="server" Enabled="true" />
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblOverrideTitle", "Override window title", ChkOverridePageTitle, true)%></td>
                        <td>
                            <asp:CheckBox ID="ChkOverridePageTitle" runat="server" Enabled="true" />
                        </td>
                    </tr> 
                    <tr>
                        <td class="key"><%=base.GetLabel("LblShowModuleTitle", "Show module title", ChkShowModuleTitle, true)%></td>
                        <td>
                            <asp:CheckBox ID="ChkShowModuleTitle" runat="server" Enabled="true" />                        
                        </td>
                    </tr>
                    </table>
                </fieldset>
            </div>
            
            <div class="col width-50">
                <fieldset class="adminForm recordInfo">
                    <legend><%=base.GetLabel("LblRecordInfo", "Record info") %></legend>
                    <table cellspacing="0" class="adminTable">
                        <tr>
                            <td class="key"><strong>ID</strong></td>
                            <td><asp:Label ID="LblId" runat="server" Text=""></asp:Label></td>
                        </tr>
                        <tr>
                            <td class="key"><strong>Module Id</strong></td>
                            <td><asp:Label ID="LblModuleId" runat="server" Text=""></asp:Label></td>
                        </tr>
                        <tr>
                            <td class="key"><strong>Core</strong></td>
                            <td>
                                <asp:CheckBox ID="ChkIsCore" runat="server" Enabled="false" />
                            </td>
                        </tr>
                    </table>
                </fieldset>
                
                <fieldset class="adminForm">
                    <uc1:PermissionsControl ID="PermissionsControl1" runat="server" />
                </fieldset>
                
                <fieldset class="adminForm">
                    <legend><%=base.GetLabel("LblViews", "Views") %></legend>
                    <table cellspacing="0" class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblViews", "Views", DropViews, true)%></td>
                        <td>
                            <asp:DropDownList ID="DropViews" runat="server" CssClass="adminMediumText locked"
                            AutoPostBack="true" OnSelectedIndexChanged="DropViews_SelectedIndexChanged"></asp:DropDownList>
                            <a href="javascript:void(0)" onclick="changeView();" id="lnkChangeView" runat="server">
                            <%=base.GetLabel("LblChange", "change", null, true) %>
                            </a>
                        </td>
                    </tr>                   
                    </table>
                </fieldset>
                
                <fieldset class="adminForm">
                    <legend><%=base.GetLabel("LblParameters", "Parameters") %></legend>
                    <uc1:ModuleParams ID="ModuleParams1" runat="server" />
                </fieldset>
            </div>
        </asp:View>
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>     
