<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_ModulesAdmin" %>
<%@ Register src="~/Controls/ModuleParams.ascx" tagname="ModuleParams" tagprefix="uc1" %>
<%@ Register src="~/Controls/PermissionsControl.ascx" tagname="PermissionsControl" tagprefix="uc1" %>

<asp:ScriptManager ID="ScriptManager1" EnablePartialRendering="true" runat="server"></asp:ScriptManager>
<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>

<script type="text/javascript">
function disableListMenu()
{
    document.getElementById('<%=ListMenu.ClientID %>').disabled = 'disabled';
}
function enableListMenu()
{
    document.getElementById('<%=ListMenu.ClientID %>').disabled = '';
}

function changeView() {
    var elemname = '#<%=DropViews.ClientID %>';
    $(elemname).removeAttr('disabled');
    $(elemname).removeClass('locked');
    $('#lnkChangeView').hide();
}

function pageLoad(sender, args) {
    $("div.fancy a").fancybox({
        'width': '75%',
        'height': '75%',
        'type': 'iframe',
        'hideOnContentClick': false,
        onClosed: function () { }
    });
}
</script>

<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>
    
    <asp:Label ID="LblErr" runat="server" Text="" CssClass="error"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>
    
    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0" OnActiveViewChanged="MultiView1_ActiveViewChanged">
    
        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar">
                <%=PigeonCms.Utility.GetLabel("LblCreateNew", "Create new")%>&nbsp;
                <asp:DropDownList runat="server" ID="DropNewModule"  AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropNewModule_SelectedIndexChanged">
                </asp:DropDownList>
            </div>
            <fieldset class="adminFilters">
                    <%=PigeonCms.Utility.GetLabel("LblFilters")%>&nbsp;
                    <asp:DropDownList runat="server" ID="DropPublishedFilter" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropPublishedFilter_SelectedIndexChanged">
                    </asp:DropDownList>
                    <asp:DropDownList runat="server" ID="DropTemplateBlockNameFilter" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropTemplateBlockNameFilter_SelectedIndexChanged">
                    </asp:DropDownList>
                    <asp:DropDownList runat="server" ID="DropModuleTypesFilter"  AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropModuleTypesFilter_SelectedIndexChanged">
                    </asp:DropDownList>
            </fieldset>
            <br />
            <asp:GridView ID="Grid1" runat="server" Width="100%" AllowPaging="True" AllowSorting="true" AutoGenerateColumns="False"
                DataSourceID="ObjDs1" DataKeyNames="Id" OnRowCommand="Grid1_RowCommand" OnRowCreated="Grid1_RowCreated" OnRowDataBound="Grid1_RowDataBound">
                <Columns>
                    <asp:TemplateField ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkSel" CommandName="Select" CommandArgument='<%#Eval("Id") %>' 
                            runat="server" SkinID="ImgEditFile" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="Title" HeaderText="Title" SortExpression="Title" />
                    <asp:BoundField DataField="TemplateBlockName" HeaderText="TemplateBlockName" SortExpression="TemplateBlockName" />
                    
                    <asp:TemplateField HeaderText="Menu" SortExpression="MenuSelection">
                        <ItemTemplate>
                        <asp:Literal ID="LitMenuEntries" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Module name" SortExpression="ModuleNamespace, ModuleName">
                        <ItemTemplate>
                        <asp:Literal ID="LitModuleNameDesc" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField ItemStyle-Width="10" ItemStyle-HorizontalAlign="Center" HeaderText="Module content">
                        <ItemTemplate>
                            <div class="fancy">
                            <asp:HyperLink runat="server" ID="LnkModuleContent" Visible="false">
                            <asp:Image ID="ImgAttribute" runat="server" SkinID="ImgAttributes" AlternateText="" Visible="true" />
                            </asp:HyperLink>
                            </div>
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField HeaderText="Published" ItemStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                            <asp:ImageButton runat="server" ID="ImgPublishedOk" CommandName="ImgPublishedOk" CommandArgument='<%#Eval("Id") %>' SkinID="ImgOk" Visible="false" />
                            <asp:ImageButton runat="server" ID="ImgPublishedKo" CommandName="ImgPublishedKo" CommandArgument='<%#Eval("Id") %>' SkinID="ImgUnchecked" Visible="false" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField HeaderText="Access type">
                        <ItemTemplate>
                        <asp:Literal ID="LitAccessTypeDesc" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField HeaderText="Access Level" SortExpression="AccessCode, AccessLevel">
                        <ItemTemplate>
                        <asp:Literal ID="LitAccessLevel" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField ItemStyle-HorizontalAlign="Right" ItemStyle-Width="25" ItemStyle-BorderStyle="None">
                        <ItemTemplate>
                            <asp:ImageButton ID="ImgMoveUp" CommandName="MoveUp" CommandArgument='<%#Eval("Id") %>'
                            SkinID="ImgSortAsc" runat="server" />
                            <asp:ImageButton ID="ImgMoveDown" CommandName="MoveDown" CommandArgument='<%#Eval("Id") %>'
                            SkinID="ImgSortDesc" runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="Ordering" HeaderText="Order" SortExpression="Ordering" ItemStyle-HorizontalAlign="Right" />
                    
                    <asp:TemplateField HeaderText="Copy" Visible="true" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center" HeaderStyle-Width="25">
                        <ItemTemplate>
                            <asp:ImageButton ID="LnkCopy" CommandName="CopyRow" CommandArgument='<%#Eval("Id") %>' runat="server" 
                                SkinID="ImgCopy" />
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField HeaderText="Core" SortExpression="IsCore" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                        <asp:CheckBox Enabled="false" Checked='<%#Eval("IsCore") %>' runat="server" />                
                        </ItemTemplate>
                    </asp:TemplateField>                    

                    <asp:TemplateField HeaderText="Del" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center" HeaderStyle-Width="25">
                        <ItemTemplate>
                            <asp:ImageButton ID="LnkDel" CommandName="DeleteRow" CommandArgument='<%#Eval("Id") %>' runat="server" 
                                SkinID="ImgDelFile" OnClientClick="return confirm('Cancellare la riga?');"  />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="Id" HeaderText="ID" SortExpression="Id" />
                </Columns>
            </asp:GridView>
            
            <asp:ObjectDataSource ID="ObjDs1" runat="server" SortParameterName="sort" OnSelecting="ObjDs1_Selecting"
                SelectMethod="GetByFilter" TypeName="PigeonCms.ModulesManager">
                <SelectParameters>
                    <asp:Parameter Name="filter" Type="object" />
                    <asp:Parameter Name="sort" Type="String" DefaultValue="Nome" />
                </SelectParameters>
                <DeleteParameters>
                    <asp:Parameter Name="Id" Type="Int32" />
                </DeleteParameters>
            </asp:ObjectDataSource>
        </asp:View>
   

        <asp:View ID="ViewInsert" runat="server">
        
            <div class="adminToolbar">
                <asp:Button ID="BtnSave" runat="server" Text="<%$ Resources:PublicLabels, CmdSave %>" CssClass="button" OnClick="BtnSave_Click" />
                <asp:Button ID="BtnCancel" runat="server" Text="<%$ Resources:PublicLabels, CmdCancel %>" CssClass="button" OnClick="BtnCancel_Click" />
            </div>
    
            <div class="col width-50">
                            
                <fieldset class="adminForm">
                    <legend><%=base.GetLabel("LblDetails", "Details") %></legend>
                    
                    <table cellspacing="0" class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblModuleType", "Module type", null, true)%></td>
                        <td colspan="3">
                            <asp:Literal ID="LitModuleType" runat="server"></asp:Literal></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblTitle", "Title", null, true)%></td>
                        <td colspan="3">
                            <asp:Panel runat="server" ID="PanelTitle"></asp:Panel>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblShowTitle", "Show title", ChkShowTitle, true)%></td>
                        <td colspan="3">
                            <asp:CheckBox ID="ChkShowTitle" runat="server" Enabled="true" /></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblPublished", "Published", ChkPublished, true)%></td>
                        <td colspan="3">
                            <asp:CheckBox ID="ChkPublished" runat="server" Enabled="true" /></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblPosition", "Position", DropTemplateBlockName, true)%></td>
                        <td colspan="3">
                            <asp:DropDownList ID="DropTemplateBlockName" CssClass="adminMediumText" runat="server">
                            </asp:DropDownList></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblOrder", "Order", DropOrdering, true)%></td>
                        <td colspan="3">
                            <asp:DropDownList ID="DropOrdering" CssClass="adminMediumText" runat="server">
                            </asp:DropDownList></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblContent", "Content", TxtContent, true)%></td>
                        <td colspan="3">
                            <asp:TextBox ID="TxtContent" Rows="3" runat="server" CssClass="adminMediumText"></asp:TextBox></td>
                    </tr>
                    </table>
                </fieldset>
                
                <fieldset class="adminForm">
                    <legend><%=base.GetLabel("LblMenuEntries", "Menu entries", null)%></legend>
                    <table cellspacing="0" class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblMenus", "Menus", null, true) %></td>
                        <td>
                            <asp:RadioButton GroupName="MenuSelection" ID="RadioMenuAll" runat="server" />
                                <%=base.GetLabel("LblMenuAll", "All", RadioMenuAll, true)%><br />
                            <asp:RadioButton GroupName="MenuSelection" ID="RadioMenuNone" runat="server" />
                                <%=base.GetLabel("LblMenuNone", "None", RadioMenuNone, true)%><br />
                            <asp:RadioButton GroupName="MenuSelection" ID="RadioMenuSelection" runat="server" />
                                <%=base.GetLabel("LblMenuSelection", "Select menu items", RadioMenuSelection, true)%><br />
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblMenuEntries", "Menu entries", ListMenu, true)%></td>
                        <td>
                            <asp:ListBox ID="ListMenu" SelectionMode="Multiple" Rows="18" runat="server">
                            </asp:ListBox>
                        </td>
                    </tr>  
                    </table>
                </fieldset>
            </div>
            
            <div class="col width-50">

                <fieldset class="adminForm recordInfo">
                <legend><%=base.GetLabel("LblRecordInfo", "Record info")%></legend>
                <table cellspacing="0" class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblRecordId", "ID") %></td>
                        <td><asp:Label ID="LblId" runat="server" Text=""></asp:Label></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblCreated", "Created")%></td>
                        <td><asp:Label ID="LblCreated" runat="server" Text=""></asp:Label></td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblLastUpdate", "Last update")%></td>
                        <td><asp:Label ID="LblUpdated" runat="server" Text=""></asp:Label></td>
                    </tr>
                    <tr>
                        <td class="key"><strong>Core</strong></td>
                        <td><asp:CheckBox ID="ChkIsCore" runat="server" Enabled="false" /></td>
                    </tr>
                </table>
                </fieldset>

                <fieldset class="adminForm">
                    <uc1:PermissionsControl ID="PermissionsControl1" runat="server" />
                </fieldset>

                <fieldset class="adminForm">
                    <legend><%=base.GetLabel("LblViews", "Views")%></legend>
                    <table cellspacing="0" class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblViews", "Views", DropViews, true)%></td>
                        <td>
                            <asp:DropDownList ID="DropViews" runat="server" CssClass="adminMediumText locked"
                            AutoPostBack="true" OnSelectedIndexChanged="DropViews_SelectedIndexChanged"></asp:DropDownList>
                            <a href="javascript:void(0)" onclick="changeView();" id="lnkChangeView" runat="server">
                            <%=base.GetLabel("LblChange", "change", null, true) %>
                            </a>
                        </td>
                    </tr>
                    </table>
                </fieldset>

                <fieldset class="adminForm">
                    <legend><%=base.GetLabel("LblParameters", "Parameters")%></legend>
                    <uc1:ModuleParams ID="ModuleParams1" runat="server" />
                </fieldset>
            </div>
            <div class="clear"/>
        </asp:View>
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>