<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_Default" %>

<script type="text/javascript">
    // <!CDATA[

    //use in popup version
    function closePopup() { parent.$.fancybox.close(); }

    // ]]>
</script>

<asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>
    
<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>

    <asp:Label ID="LblErr" runat="server" Text="" CssClass="error"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>

    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0" 
        onactiveviewchanged="MultiView1_ActiveViewChanged">
    
        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar">
                <asp:Button ID="BtnNew" runat="server" Text="<%$ Resources:PublicLabels, CmdNew %>" CssClass="button" OnClick="BtnNew_Click" />
            </div>
            <br />
            <asp:GridView ID="Grid1" Width="100%" runat="server" AllowPaging="True" AllowSorting="false" AutoGenerateColumns="False"
                DataSourceID="ObjDs1" DataKeyNames="Name" OnRowCommand="Grid1_RowCommand" OnRowCreated="Grid1_RowCreated">
                <Columns>
                    <asp:TemplateField ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkSel" CommandName="Select" CommandArgument='<%#Eval("Name") %>' 
                        runat="server" SkinID="ImgEditFile" />                
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="Name" HeaderText="Nome" SortExpression="Name" />
                    <asp:TemplateField HeaderText="Visibile" SortExpression="Visible">
                        <ItemTemplate>
                        <asp:CheckBox ID="CheckBox1" Enabled="false" Checked='<%#Eval("Visible") %>' runat="server" />                
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField ItemStyle-HorizontalAlign="Right" HeaderStyle-Width="20">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkDel" CommandName="DeleteRow" CommandArgument='<%#Eval("Name") %>' runat="server" SkinID="ImgDelFile" 
                        OnClientClick="return confirm('Cancellare la riga?');"  />
                        </ItemTemplate>
                    </asp:TemplateField>
                </Columns>
            </asp:GridView>
            
            <asp:ObjectDataSource ID="ObjDs1" runat="server" SortParameterName="sort"
                SelectMethod="GetByFilter" TypeName="PigeonCms.PlaceholdersManager" OnSelecting="ObjDs1_Selecting">
                <SelectParameters>
                    <asp:Parameter Name="filter" Type="Object" />
                    <asp:Parameter Name="sort" Type="String" />
                </SelectParameters>
                <DeleteParameters>
                    <asp:Parameter Name="Name" Type="String" />
                </DeleteParameters>
            </asp:ObjectDataSource>
        </asp:View>

        <asp:View ID="ViewInsert" runat="server">
        
            <div class="adminToolbar">
                <asp:Button ID="BtnSave" runat="server" Text="<%$ Resources:PublicLabels, CmdSave %>" CssClass="button" OnClick="BtnSave_Click" />
                <asp:Button ID="BtnCancel" runat="server" Text="<%$ Resources:PublicLabels, CmdCancel %>" CssClass="button" OnClick="BtnCancel_Click" />
            </div>        
            
            <div class="col width-100">
            <fieldset class="adminForm">
                <legend></legend>
                <asp:TextBox ID="TxtId" runat="server" Enabled="false" visible="false"></asp:TextBox>
                <asp:TextBox ID="TxtOrderId" MaxLength="10" Visible="false" runat="server"></asp:TextBox>
                <table class="adminTable">
                <tr>
                    <td class="key"><%=base.GetLabel("LblName", "Name", TxtName, true)%></td>
                    <td>
                        <asp:TextBox ID="TxtName" MaxLength="50" runat="server" Enabled="false" Width="255px"></asp:TextBox>
                    </td>
                </tr>
                <tr>
                    <td class="key" colspan="2">
                    <%=base.GetLabel("LblContent", "Content", null, true)%>
                    </td>
                </tr>
                <tr>
                    <td colspan="2">
                        <asp:TextBox ID="TxtContent" MaxLength="500" runat="server" Width="580px" Height="200px" TextMode="MultiLine"></asp:TextBox>
                    </td>
                </tr>            
                <tr>
                    <td class="key"><%=base.GetLabel("LblVisible", "Visible", ChkVisibile, true)%></td>
                    <td class="listItemAlternate">
                        <asp:CheckBox ID="ChkVisibile" runat="server" Enabled="true" />
                    </td>
                </tr>
                </table>
            </fieldset>
            </div>
        </asp:View>
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>