<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_Default" %>
<%@ Register Assembly="DayPilot" Namespace="DayPilot.Web.Ui" TagPrefix="DayPilot" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="cc1" %>

<script type="text/javascript">
// <!CDATA[

// ]]>
</script>

<asp:ScriptManager ID="ScriptManager1" runat="server" EnableScriptGlobalization="true"></asp:ScriptManager>
<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>


<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>
    <h1><%=PigeonCms.Utility.GetLabel("LblReservationsManager", "Gestione prenotazioni") %></h1>
    <asp:Label ID="LblErr" runat="server" Text="" CssClass="error"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>

    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0" OnActiveViewChanged="MultiView1_ActiveViewChanged">

        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar">
                <asp:Button ID="BtnNew" runat="server" Text="<%$ Resources:PublicLabels, CmdNew %>" CssClass="button" OnClick="BtnNew_Click" />
            </div>
            <br />
            
            <asp:Calendar ID="Cal1" runat="server" CssClass="DayPilotCalendar"
                OnSelectionChanged="Cal1_SelectionChanged" DayNameFormat="FirstTwoLetters">
                <TodayDayStyle BorderColor="Red" BorderStyle="Solid" BorderWidth="1px"></TodayDayStyle>
                <SelectedDayStyle BackColor="#FBE694" ForeColor="Black" CssClass="selected"></SelectedDayStyle>
                <TitleStyle BackColor="White"></TitleStyle>
                <OtherMonthDayStyle ForeColor="#ACA899"></OtherMonthDayStyle>
            </asp:Calendar>

            <DayPilot:DayPilotScheduler  ID="DayPilot1" runat="server" Days="7" CellDuration="1440"
                DataStartField="EventStart" DataEndField="EventEnd" DataTextField="Description"
                DataValueField="Id" DataResourceField="ResourceId" 
                FreeTimeClickHandling="PostBack" EventClickHandling="PostBack"
                OnEventClick="DayPilot1_EventClick" OnFreeTimeClick="DayPilot1_FreeTimeClick">
                <Resources>
                </Resources>
            </DayPilot:DayPilotScheduler>
            
        </asp:View>
   

        <asp:View ID="ViewInsert" runat="server">
        
            <div class="adminToolbar">
                <asp:Button ID="BtnSave" runat="server" Text="<%$ Resources:PublicLabels, CmdSave %>" CssClass="button" OnClick="BtnSave_Click" />
                <asp:Button ID="BtnCancel" runat="server" Text="<%$ Resources:PublicLabels, CmdCancel %>" CssClass="button" OnClick="BtnCancel_Click" />
                <asp:Button ID="BtnDelete" runat="server" Text="<%$ Resources:PublicLabels, CmdDelete %>" CssClass="button" OnClick="BtnDelete_Click" />
            </div>
            
            <div class="col width-100">
                <fieldset class="adminForm">
                    <legend></legend>
                    <table class="adminTable">
                    <tr>
                        <td class="key">Camera</td>
                        <td>
                            <asp:DropDownList ID="DropItems" runat="server" CssClass="adminMediumText"></asp:DropDownList>
                        </td>
                    </tr>
                    <tr>
                        <td class="key">Giorno di arrivo</td>
                        <td class="calendar">
                            <asp:TextBox ID="TxtEventStart" runat="server" ValidationGroup="SearchForm"
                                CssClass='adminSmallText'></asp:TextBox>        
                            <cc1:CalendarExtender ID="CalEventStart" runat="server"
                                TargetControlID="TxtEventStart" Format="dd/MM/yyyy"></cc1:CalendarExtender>
                        </td>
                    </tr>
                    <tr>
                        <td class="key">Giorno di partenza</td>
                        <td class="calendar">
                            <asp:TextBox ID="TxtEventEnd" runat="server" ValidationGroup="SearchForm"
                                CssClass='adminSmallText'></asp:TextBox>        
                            <cc1:CalendarExtender ID="CalEventEnd" runat="server" FirstDayOfWeek="Monday"
                                TargetControlID="TxtEventEnd" Format="dd/MM/yyyy"></cc1:CalendarExtender>
                            <asp:RequiredFieldValidator ID="RequiredEventEnd" runat="server" ControlToValidate="TxtEventEnd"
                                ValidationGroup="SearchForm" ErrorMessage="Inserire il giorno di partenza">*</asp:RequiredFieldValidator>
                        </td>
                    </tr>
                    <tr>
                        <td class="key">Stato</td>
                        <td>
                            <asp:DropDownList runat="server" ID="DropStatus" CssClass="adminMediumText">
                            </asp:DropDownList>
                        </td>
                    </tr> 
                    <tr>
                        <td class="key">Titolo</td>
                        <td>
                            <asp:TextBox ID="TxtName" CssClass="adminText" runat="server"></asp:TextBox>
                        </td>
                    </tr>
                    <tr>
                        <td class="key">Note</td>
                        <td>
                            <asp:TextBox ID="TxtDescription" CssClass="adminText" TextMode="MultiLine" Rows="4" runat="server"></asp:TextBox>
                        </td>
                    </tr>
                    </table>
                </fieldset>
            </div>
            
            <div class="clear"/>
        </asp:View>
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>