<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_Default" %>

<asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>

<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>
    <asp:Label ID="LblErr" runat="server" Text="" CssClass="error"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>

    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0">

        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar">
                <asp:Button ID="BtnNew" runat="server" Text="Nuovo" CssClass="button" OnClick="BtnNew_Click" />
                <asp:Button ID="BtnApplySettings" runat="server" Text="Applica" CssClass="button" OnClick="BtnApply_Click" />
            </div>
            <fieldset title="Filtri">
                Published 
                    <asp:DropDownList runat="server" ID="DropPublishedFilter" AutoPostBack="true" CssClass="adminShortText" OnSelectedIndexChanged="DropPublishedFilter_SelectedIndexChanged">
                        <asp:ListItem Value="">Not set</asp:ListItem>
                        <asp:ListItem Value="1">On-line</asp:ListItem>
                        <asp:ListItem Value="0">Off-line</asp:ListItem>
                    </asp:DropDownList>&nbsp;&nbsp;&nbsp;
            </fieldset>
            <br />
            <asp:GridView ID="Grid1" runat="server" AllowPaging="True" AllowSorting="false" Width="100%" AutoGenerateColumns="False"
                DataSourceID="ObjDs1" DataKeyNames="Id" OnRowCommand="Grid1_RowCommand" OnRowCreated="Grid1_RowCreated" OnRowDataBound="Grid1_RowDataBound">
                <Columns>
                    <asp:TemplateField ItemStyle-HorizontalAlign="Right" ItemStyle-Width="10">
                        <ItemTemplate>
                            <asp:ImageButton ID="ImgMoveUp" CommandName="MoveUp" CommandArgument='<%#Eval("Id") %>'
                            SkinID="ImgSortAsc" runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField ItemStyle-HorizontalAlign="Right" ItemStyle-Width="10">
                        <ItemTemplate>
                            <asp:ImageButton ID="ImgMoveDown" CommandName="MoveDown" CommandArgument='<%#Eval("Id") %>'
                            SkinID="ImgSortDesc" runat="server" />
                        </ItemTemplate>
                    </asp:TemplateField>                
                    <asp:TemplateField ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkSel" CommandName="Select" CommandArgument='<%#Eval("Id") %>' 
                        runat="server" SkinID="ImgEditFile" />                
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="Name" HeaderText="Name" SortExpression="Name" />
                    <asp:BoundField DataField="Pattern" HeaderText="Pattern" SortExpression="Pattern" />
                    <asp:BoundField DataField="CurrTheme" HeaderText="Theme" SortExpression="CurrTheme" />
                    <asp:BoundField DataField="CurrMasterpage" HeaderText="Masterpage" SortExpression="CurrMasterpage" />
                    <asp:BoundField DataField="Ordering" HeaderText="Order" SortExpression="Ordering"
                        ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center" />

                    <asp:TemplateField HeaderText="Use SSL" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                            <asp:ImageButton runat="server" ID="ImgUseSslOk" CommandName="ImgUseSslOk" CommandArgument='<%#Eval("Id") %>' SkinID="ImgSecurity" Visible="false" />
                            <asp:ImageButton runat="server" ID="ImgUseSslKo" CommandName="ImgUseSslKo" CommandArgument='<%#Eval("Id") %>' SkinID="ImgUnchecked" Visible="false" />
                        </ItemTemplate>
                    </asp:TemplateField>
                        
                    <asp:TemplateField HeaderText="Published" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                            <asp:ImageButton runat="server" ID="ImgEnabledOk" CommandName="ImgEnabledOk" CommandArgument='<%#Eval("Id") %>' SkinID="ImgOk" Visible="false" />
                            <asp:ImageButton runat="server" ID="ImgEnabledKo" CommandName="ImgEnabledKo" CommandArgument='<%#Eval("Id") %>' SkinID="ImgUnchecked" Visible="false" />
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Core" SortExpression="IsCore" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                        <asp:CheckBox Enabled="false" Checked='<%#Eval("IsCore") %>' runat="server" />                
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="" ItemStyle-HorizontalAlign="Center" ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkDel" CommandName="DeleteRow" CommandArgument='<%#Eval("Id") %>' 
                        runat="server" SkinID="ImgDelFile" 
                        OnClientClick="return confirm('Cancellare la riga?');"  />
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:BoundField DataField="Id" HeaderText="ID" ItemStyle-HorizontalAlign="Right" HeaderStyle-HorizontalAlign="Right" />
                </Columns>
            </asp:GridView>
            
            <asp:ObjectDataSource ID="ObjDs1" runat="server" SortParameterName="sort"
                SelectMethod="GetByFilter" TypeName="PigeonCms.MvcRoutesManager" OnSelecting="ObjDs1_Selecting">
                <SelectParameters>
                    <asp:Parameter Name="filter" Type="Object" />
                    <asp:Parameter Name="sort" Type="String" DefaultValue="Ordering" />
                </SelectParameters>
                <DeleteParameters>
                    <asp:Parameter Name="Id" Type="Int32" />
                </DeleteParameters>
            </asp:ObjectDataSource>
        </asp:View>
   

        <asp:View ID="ViewInsert" runat="server">
            <div class="adminToolbar">
                <asp:Button ID="BtnSave" runat="server" Text="<%$ Resources:PublicLabels, CmdSave %>" CssClass="button" OnClientClick="MyObject.UpdateEditorFormValue();" OnClick="BtnSave_Click" />
                <asp:Button ID="BtnCancel" runat="server" Text="<%$ Resources:PublicLabels, CmdCancel %>" CssClass="button" OnClick="BtnCancel_Click" />
            </div>
            
            <div class="col width-100">
                <fieldset class="adminForm">
                    <legend></legend>
                    <table class="adminTable">
                    <tr>
                        <td><strong>ID</strong></td>
                        <td><asp:Label ID="LitId" runat="server" Text=""></asp:Label></td>
                    </tr>
                    <tr>
                        <td class="">Core</td>
                        <td>
                            <asp:CheckBox ID="ChkIsCore" runat="server" Enabled="false" />
                        </td>
                    </tr>                    
                    <tr>
                        <td class="key"><%=PigeonCms.Utility.GetLabel("LblName", "Name", TxtName) %></td>
                        <td>
                            <asp:TextBox ID="TxtName" MaxLength="50" runat="server" CssClass="adminMediumText"></asp:TextBox>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=PigeonCms.Utility.GetLabel("LblPattern", "Pattern", TxtPattern) %></td>
                        <td>
                            <asp:TextBox ID="TxtPattern" MaxLength="255" runat="server" CssClass="adminText"></asp:TextBox>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=PigeonCms.Utility.GetLabel("LblEnabled", "Enabled", ChkPublished) %></td>
                        <td>
                            <asp:CheckBox ID="ChkPublished" runat="server" Enabled="true" />
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=PigeonCms.Utility.GetLabel("LblUseSsl", "Use SSL", ChkUseSsl) %></td>
                        <td>
                            <asp:CheckBox ID="ChkUseSsl" runat="server" Enabled="true" />
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=PigeonCms.Utility.GetLabel("", "Theme", DropTheme)%></td>
                        <td>
                            <asp:DropDownList ID="DropTheme" CssClass="adminMediumText" runat="server">
                            </asp:DropDownList></td>
                    </tr>
                    <tr>
                        <td class="key"><%=PigeonCms.Utility.GetLabel("", "Masterpage", DropMasterPage)%></td>
                        <td>
                            <asp:DropDownList ID="DropMasterPage" CssClass="adminMediumText" runat="server">
                            </asp:DropDownList></td>
                    </tr>
                    </table>
                </fieldset>
            </div>

        </asp:View>
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>