<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_SectionsAdmin" %>
<%@ Register src="~/Controls/PermissionsControl.ascx" tagname="PermissionsControl" tagprefix="uc1" %>

<script type="text/javascript">
// <!CDATA[

function pageLoad(sender, args) 
{
    $("div.fancy a").fancybox({
        'width': '75%',
        'height': '75%',
        'type': 'iframe',
        'hideOnContentClick': false,
        onClosed: function() { }
    });
}

// ]]>
</script>

<asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>

<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>

    <asp:Label ID="LblErr" runat="server" Text="" CssClass="error"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>

    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0">

        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar">
                <asp:Button ID="BtnNew" runat="server" Text="<%$ Resources:PublicLabels, CmdNew %>" CssClass="button" OnClick="BtnNew_Click" />
            </div>
            <fieldset class="adminFilters">
                <%=base.GetLabel("LblFilters", "Filters")%>&nbsp;
                    <asp:DropDownList runat="server" ID="DropEnabledFilter" AutoPostBack="true" CssClass="adminMediumText" OnSelectedIndexChanged="DropEnabledFilter_SelectedIndexChanged">
                    </asp:DropDownList>
            </fieldset>
            <br />
            <asp:GridView ID="Grid1" runat="server" AllowPaging="True" AllowSorting="true" Width="100%" AutoGenerateColumns="False"
                DataSourceID="ObjDs1" DataKeyNames="Id" OnRowCommand="Grid1_RowCommand" OnRowCreated="Grid1_RowCreated" OnRowDataBound="Grid1_RowDataBound">
                <Columns>
                    <asp:TemplateField ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkSel" CommandName="Select" CommandArgument='<%#Eval("Id") %>' 
                        runat="server" SkinID="ImgEditFile" />                
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="Title" HeaderText="Titolo" />
                    
                    <asp:TemplateField HeaderText="Abilitato" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center">
                        <ItemTemplate>
                            <asp:ImageButton runat="server" ID="ImgEnabledOk" CommandName="ImgEnabledOk" CommandArgument='<%#Eval("Id") %>' SkinID="ImgOk" Visible="false" />
                            <asp:ImageButton runat="server" ID="ImgEnabledKo" CommandName="ImgEnabledKo" CommandArgument='<%#Eval("Id") %>' SkinID="ImgUnchecked" Visible="false" />
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField HeaderText="Access type" SortExpression="AccessType">
                        <ItemTemplate>
                        <asp:Literal ID="LitAccessTypeDesc" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Access Level" SortExpression="AccessCode, AccessLevel">
                        <ItemTemplate>
                        <asp:Literal ID="LitAccessLevel" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Files" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center" HeaderStyle-Width="60">
                        <ItemTemplate>
                            <div class="fancy">
                                <asp:HyperLink runat="server" ID="LnkUploadFiles">
                                <asp:Image ID="FilesUpload" runat="server" SkinID="ImgUpload" AlternateText="Gestione files" Visible="true" ToolTip="Gestione files" />
                                </asp:HyperLink>
                            </div>
                            <span><asp:Literal ID="LitFilesCount" runat="server" Text=""></asp:Literal></span>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="Immagini" ItemStyle-HorizontalAlign="Center" HeaderStyle-HorizontalAlign="Center" HeaderStyle-Width="60">
                        <ItemTemplate>
                            <div class="fancy">
                                <asp:HyperLink runat="server" ID="LnkUploadImg">
                                <asp:Image ID="ImgUpload" runat="server" SkinID="ImgUpload" AlternateText="Gestione immagini" Visible="true" ToolTip="Gestione immagini" />
                                </asp:HyperLink>
                            </div>
                            <span><asp:Literal ID="LitImgCount" runat="server" Text=""></asp:Literal></span>
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField HeaderText="Items" SortExpression="">
                        <ItemTemplate>
                        <asp:Literal ID="LitItems" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>

                    <asp:TemplateField HeaderText="Disk space" SortExpression="">
                        <ItemTemplate>
                        <asp:Literal ID="LitDiskSpace" runat="server" Text=""></asp:Literal>
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:TemplateField HeaderText="" ItemStyle-HorizontalAlign="Center" ItemStyle-Width="10">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkDel" CommandName="DeleteRow" CommandArgument='<%#Eval("Id") %>' 
                        runat="server" SkinID="ImgDelFile" 
                        OnClientClick="return confirm('Cancellare la riga?');"  />
                        </ItemTemplate>
                    </asp:TemplateField>
                    
                    <asp:BoundField DataField="Id" HeaderText="ID" SortExpression="Id" ItemStyle-Width="10" ItemStyle-HorizontalAlign="Right" HeaderStyle-HorizontalAlign="Right" />
                </Columns>
            </asp:GridView>
            
            <asp:ObjectDataSource ID="ObjDs1" runat="server" SortParameterName="sort"
                SelectMethod="GetByFilter" TypeName="PigeonCms.SectionsManager" 
                OnObjectCreating="ObjDs1_ObjectCreating"
                OnSelecting="ObjDs1_Selecting">
                <SelectParameters>
                    <asp:Parameter Name="filter" Type="Object" />
                    <asp:Parameter Name="sort" Type="String" DefaultValue="" />
                </SelectParameters>
                <DeleteParameters>
                    <asp:Parameter Name="Id" Type="Int32" />
                </DeleteParameters>
            </asp:ObjectDataSource>
        </asp:View>
   

        <asp:View ID="ViewInsert" runat="server">

            <div class="adminToolbar">
                <asp:Button ID="BtnSave" runat="server" Text="<%$ Resources:PublicLabels, CmdSave %>" CssClass="button" OnClick="BtnSave_Click" />
                <asp:Button ID="BtnCancel" runat="server" Text="<%$ Resources:PublicLabels, CmdCancel %>" CssClass="button" OnClick="BtnCancel_Click" />
            </div>

            <div class="col width-60">
                <fieldset class="adminForm">
                    <legend></legend>
                    <table class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblTitle", "Title", null, true)%></td>
                        <td>
                            <asp:Panel runat="server" ID="PanelTitle"></asp:Panel>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblDescription", "Description", null, true)%></td>
                        <td>
                            <asp:Panel runat="server" ID="PanelDescription"></asp:Panel>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblEnabled", "Enabled", ChkEnabled, true)%></td>
                        <td>
                            <asp:CheckBox ID="ChkEnabled" runat="server" Enabled="true" />
                        </td>
                    </tr>
                    </table>
                </fieldset>

                <fieldset class="adminForm">
                    <legend><%=base.GetLabel("LblLimits", "Limits", null, true)%></legend>
                    <table class="adminTable">
                    <tr>
                        <td class="key"><%=base.GetLabel("LblMaxItems", "Max items", TxtMaxItems, true)%></td>
                        <td>
                            <asp:TextBox ID="TxtMaxItems" runat="server" CssClass="adminShortText"></asp:TextBox>
                        </td>
                    </tr>
                    <tr>
                        <td class="key"><%=base.GetLabel("LblMaxAttachSizeKB", "Max size for attachments (KB)", TxtMaxAttachSizeKB, true)%></td>
                        <td>
                            <asp:TextBox ID="TxtMaxAttachSizeKB" runat="server" CssClass="adminShortText"></asp:TextBox>
                        </td>
                    </tr>
                    </table>
                </fieldset>
            </div>

            <div class="col width-40">

                <fieldset class="adminForm">
                    <uc1:PermissionsControl ID="PermissionsControl1" runat="server" />
                </fieldset>

            </div>
        </asp:View>
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>
