<%@ Control Language="C#" AutoEventWireup="true" CodeFile="Default.ascx.cs" Inherits="Controls_StaticPagesAdmin" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="cc1" %>
<%@ Register src="~/Controls/ContentEditorControl.ascx" tagname="ContentEditorControl" tagprefix="uc1" %>
<asp:ScriptManager ID="ScriptManager1" runat="server" EnablePageMethods="true"></asp:ScriptManager>


<script type="text/javascript">
// <!CDATA[

function ismaxlength(obj){
    var mlength=obj.getAttribute ? parseInt(obj.getAttribute("maxlength")) : "";
    if (obj.getAttribute && obj.value.length > mlength)
        obj.value=obj.value.substring(0, mlength);
}

//use in popup version
function closePopup() { parent.$.fancybox.close(); }

// ]]>
</script>

<asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="1" AssociatedUpdatePanelID="Upd1">
    <ProgressTemplate>
        <div class="loading"><%=PigeonCms.Utility.GetLabel("LblLoading", "loading") %></div>
    </ProgressTemplate>
</asp:UpdateProgress>
    
<asp:UpdatePanel ID="Upd1" runat="server">
<ContentTemplate>

    <asp:Label ID="LblErr" runat="server" Text="" CssClass="errore"></asp:Label>
    <asp:Label ID="LblOk" runat="server" Text="" CssClass="success"></asp:Label>

    <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0" 
        onactiveviewchanged="MultiView1_ActiveViewChanged">
    
        <asp:View ID="ViewSee" runat="server">
            <div class="adminToolbar">
                <asp:Button ID="BtnNew" runat="server" Text="<%$ Resources:PublicLabels, CmdNew %>" CssClass="button" OnClick="BtnNew_Click" />
            </div>
            <br />
            <asp:GridView ID="Grid1" Width="100%" runat="server" AllowPaging="True" AllowSorting="false" AutoGenerateColumns="False"
                DataSourceID="ObjDs1" DataKeyNames="PageName" OnRowCommand="Grid1_RowCommand" OnRowCreated="Grid1_RowCreated">
                <Columns>
                    <asp:TemplateField>
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkSel" CommandName="Select" CommandArgument='<%#Eval("pageName") %>' 
                        runat="server" SkinID="ImgEditFile" />                
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:BoundField DataField="PageName" HeaderText="Nome" SortExpression="PageName" />
                    <asp:BoundField DataField="PageTitle" HeaderText="Titolo" SortExpression="PageTitle" />
                    <asp:TemplateField HeaderText="Visibile" SortExpression="Visible">
                        <ItemTemplate>
                        <asp:CheckBox ID="CheckBox1" Enabled="false" Checked='<%#Eval("Visible") %>' runat="server" />                
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField ItemStyle-HorizontalAlign="Right" HeaderStyle-Width="20">
                        <ItemTemplate>
                        <asp:ImageButton ID="LnkDel" CommandName="DeleteRow" CommandArgument='<%#Eval("pageName") %>' runat="server" SkinID="ImgDelFile" 
                        OnClientClick="return confirm('Cancellare la riga?');"  />
                        </ItemTemplate>
                    </asp:TemplateField>
                </Columns>
            </asp:GridView>
            
            <asp:ObjectDataSource ID="ObjDs1" runat="server" SortParameterName="sort"
                SelectMethod="GetByFilter" TypeName="PigeonCms.StaticPagesManager" OnSelecting="ObjDs1_Selecting">
                <SelectParameters>
                    <asp:Parameter Name="filter" Type="Object" />
                    <asp:Parameter Name="sort" Type="String" DefaultValue="PageName" />
                </SelectParameters>
                <DeleteParameters>
                    <asp:Parameter Name="pageName" Type="String" />
                </DeleteParameters>
            </asp:ObjectDataSource>
        </asp:View>
   

        <asp:View ID="ViewInsert" runat="server">
        
            <div class="adminToolbar">
                <asp:Button ID="BtnSave" runat="server" Text="<%$ Resources:PublicLabels, CmdSave %>" 
                    CssClass="button" OnClick="BtnSave_Click" />
                <asp:Button ID="BtnApply" runat="server" Text="<%$ Resources:PublicLabels, CmdApply %>" 
                    CssClass="button" OnClick="BtnApply_Click" />
                <asp:Button ID="BtnCancel" runat="server" Text="<%$ Resources:PublicLabels, CmdCancel %>" 
                    CssClass="button" OnClick="BtnCancel_Click" />
            </div>
            
            <div class="col width-100">
            <fieldset class="adminForm">
                <legend></legend>
                <asp:TextBox ID="TxtId" runat="server" Enabled="false" visible="false"></asp:TextBox>
                <table class="adminTable">
                <tr>
                    <td class="key"><%=base.GetLabel("LblName", "Name", TxtPageName, true)%></td>
                    <td style="width: 571px">
                        <asp:TextBox ID="TxtPageName" MaxLength="50" runat="server" Enabled="false" Width="255px"></asp:TextBox></td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblTitle", "Title", null, true)%></td>
                    <td class="listItemAlternate">
                        <asp:Panel runat="server" ID="PanelPageTitle"></asp:Panel>
                    </td>
                </tr>            
                <tr>
                    <td class="key"><%=base.GetLabel("LblShowTitle", "Show title", ChkShowPageTitle, true)%></td>
                    <td class="listItemAlternate">
                        <asp:CheckBox ID="ChkShowPageTitle" runat="server" Enabled="true" />
                    </td>
                </tr>
                <tr>
                    <td class="key"><%=base.GetLabel("LblVisible", "Visible", ChkVisibile, true)%></td>
                    <td class="listItemAlternate">
                        <asp:CheckBox ID="ChkVisibile" runat="server" Enabled="true" />
                    </td>
                </tr>
                <tr>
                    <td class="key" colspan="2"><%=base.GetLabel("LblContent", "Content", null, true)%></td>
                </tr>
                <tr>
                    <td style="vertical-align:top;" colspan="2">
                        <asp:Panel runat="server" ID="PanelPageContent"></asp:Panel>
                    </td>
                </tr>
                </table>
            </fieldset>
            </div>
        </asp:View>
    </asp:MultiView>

</ContentTemplate>
</asp:UpdatePanel>