using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Diagnostics;
using System.ComponentModel;
using System.IO;
using PigeonCms;
using System.Collections.Generic;
using System.Threading;


namespace PigeonCms
{
    
    [DebuggerDisplay("ResourceSet={resourceSet}, ResourceId={resourceId}")]
    public class ResLabelTrans : ITable
    {
        private string resourceSet = "";
        private string resourceId = "";
        private Dictionary<string, string> valueTranslations = new Dictionary<string, string>();

        public string ResourceSet
        {
            [DebuggerStepThrough()]
            get { return resourceSet; }
            [DebuggerStepThrough()]
            set { resourceSet = value; }
        }

        public string ResourceId
        {
            [DebuggerStepThrough()]
            get { return resourceId; }
            [DebuggerStepThrough()]
            set { resourceId = value; }
        }
        /*
        public string Value
        {
            get
            {
                string res = "";
                valueTranslations.TryGetValue(Thread.CurrentThread.CurrentCulture.Name, out res);
                if (string.IsNullOrEmpty(res))
                    valueTranslations.TryGetValue(Config.CultureDefault, out res);
                if (string.IsNullOrEmpty(res))
                    res = this.ResourceId;
                return res;
            }
        }

        /// <summary>
        /// Title in different culture
        /// </summary>
        [DataObjectField(false)]
        public Dictionary<string, string> ValueTranslations
        {
            [DebuggerStepThrough()]
            get { return valueTranslations; }
            [DebuggerStepThrough()]
            set { valueTranslations = value; }
        }

        public bool IsValueTranslated
        {
            get
            {
                bool res = true;
                string val = "";
                valueTranslations.TryGetValue(Thread.CurrentThread.CurrentCulture.Name, out val);
                if (string.IsNullOrEmpty(val))
                    res = false;
                return res;
            }
        }
        */
    }

    [Serializable]
    [DebuggerDisplay("ResourceSet={resourceSet}, ResourceId={resourceId}")]
    public class LabelTransFilter
    {
        private string resourceSet = "";
        private string resourceId = "";

        public string ResourceSet
        {
            [DebuggerStepThrough()]
            get { return resourceSet; }
            [DebuggerStepThrough()]
            set { resourceSet = value; }
        }

        public string ResourceId
        {
            [DebuggerStepThrough()]
            get { return resourceId; }
            [DebuggerStepThrough()]
            set { resourceId = value; }
        }
    }

    [DebuggerDisplay("CultureName={cultureName}, ResourceSet={resourceSet}, ResourceId={resourceId}")]
    public class ResLabel: ITable
    {
        private int id = 0;
        private string cultureName = "";
        private string resourceSet = "";
        private string resourceId = "";
        private string value = "";
        private string comment = "";

        /// <summary>
        /// Automatic Id as PKey
        /// </summary>
        [DataObjectField(true)]
        public int Id
        {
            [DebuggerStepThrough()]
            get { return id; }
            [DebuggerStepThrough()]
            set { id = value; }
        }

        public string CultureName
        {
            [DebuggerStepThrough()]
            get { return cultureName; }
            [DebuggerStepThrough()]
            set { cultureName = value; }
        }

        public string ResourceSet
        {
            [DebuggerStepThrough()]
            get { return resourceSet; }
            [DebuggerStepThrough()]
            set { resourceSet = value; }
        }

        public string ResourceId
        {
            [DebuggerStepThrough()]
            get { return resourceId; }
            [DebuggerStepThrough()]
            set { resourceId = value; }
        }

        public string Value
        {
            [DebuggerStepThrough()]
            get { return this.value; }
            [DebuggerStepThrough()]
            set { this.value = value; }
        }

        public string Comment
        {
            [DebuggerStepThrough()]
            get { return comment; }
            [DebuggerStepThrough()]
            set { comment = value; }
        }

        public ResLabel() { }
    }


    [Serializable]
    public class LabelsFilter
    {
        private int id = 0;
        private string cultureName = "";
        private string resourceSet = "";
        private string resourceId = "";

        /// <summary>
        /// Automatic Id as PKey
        /// </summary>
        [DataObjectField(true)]
        public int Id
        {
            [DebuggerStepThrough()]
            get { return id; }
            [DebuggerStepThrough()]
            set { id = value; }
        }

        public string CultureName
        {
            [DebuggerStepThrough()]
            get { return cultureName; }
            [DebuggerStepThrough()]
            set { cultureName = value; }
        }

        public string ResourceSet
        {
            [DebuggerStepThrough()]
            get { return resourceSet; }
            [DebuggerStepThrough()]
            set { resourceSet = value; }
        }

        public string ResourceId
        {
            [DebuggerStepThrough()]
            get { return resourceId; }
            [DebuggerStepThrough()]
            set { resourceId = value; }
        }
    }
}